# クイックスタート

## CDK
以下を実行し、AWSリソースをデプロイする

```bash
cd buildersflash202308/cdk/
npm install 
cdk bootstrap
cdk deploy
```

## server
以下を実行し、デプロイした GameLift リソースに接続するゲームサーバーを起動する
```bash
cd buildersflash202308/server/

FLEETID=<FLEETID from CDK output>
IP=127.0.0.1
COMPUTE_NAME=localpc
LOCATION=custom-localMachine

RESPONSE=$(aws gamelift register-compute --fleet-id $FLEETID \
--compute-name $COMPUTE_NAME --location $LOCATION --ip-address $IP --dns-name "localhost")
ENDPOINT=$(echo $RESPONSE | jq -r '.Compute.GameLiftServiceSdkEndpoint')

CREDS=$(aws gamelift get-compute-auth-token --fleet-id $FLEETID --compute-name $COMPUTE_NAME)
TOKEN=$(echo $CREDS | jq -r '.AuthToken')

go run . --websocketurl $ENDPOINT --hostid $COMPUTE_NAME --fleetid $FLEETID --authtoken $TOKEN
```

## client

- buildersflash202308/client/ ディレクトリを Unity で開く
- ヒエラルキーの GameManager を選択し、アタッチされている Rest API Manager の空欄を埋める
- API Gateway Domain : デプロイした API Gateway のドメインのみ入力
- Api Key : CDK を使用してデプロイした際に設定した値を入力
- エディターから起動するか、アプリケーションをビルドして実行する
