using System.Text;
using NativeWebSocket;
using UnityEngine;


public class WebSocketManager : MonoBehaviour
{
    WebSocket websocket;
    public static WebSocketManager instance;

    void Start()
    {
        instance = this.GetComponent<WebSocketManager>();
    }

    public async void Connect(string ipAddress, string port)
    {
        websocket = new WebSocket("ws://" + ipAddress + ":" + port + "/connect");

        websocket.OnMessage += (bytes) =>
        {
            Debug.Log("OnMessage!");
            GameManager.instance.OnReceivedMessageQueue.Enqueue(Encoding.UTF8.GetString(bytes));
        };

        await websocket.Connect();
    }

    void Update()
    {
        if (websocket == null)
            return;
        if (websocket.State != WebSocketState.Open)
            return;
#if !UNITY_WEBGL || UNITY_EDITOR
        websocket.DispatchMessageQueue();
#endif
    }

    public async void SendWebSocketMessage(string message)
    {
        if (websocket.State == WebSocketState.Open)
            await websocket.Send(Encoding.UTF8.GetBytes(message));
    }

    public async void SendWebSocketMessageButton()
    {
        if (websocket.State == WebSocketState.Open)
            await websocket.Send(Encoding.UTF8.GetBytes("message"));
    }

    private async void OnApplicationQuit()
    {
        await websocket.Close();
    }
}